<template>
  <div>
    <v-dialog v-model="abrirForm" width="800">
      <form-turnos v-if="abrirForm" @onImprimir="imprimirTurno" @onClose="abrirForm = false" />
    </v-dialog>
    <v-col>
      <v-btn color="accent" @click="abrirForm = !abrirForm">
        <v-icon left>
          fal fa-plus
        </v-icon>
        Nuevo turno
      </v-btn>
      <v-btn :block="$vuetify.breakpoint.smAndDown" color="seconday" @click="dialogPeriodo=true">
        Filtrar período
      </v-btn>
    </v-col>
    <calendar />
    <up-web-view v-if="showDialogPDF" :url="urlPDF" @onClose="showDialogPDF=false" />
    <v-dialog v-model="dialogPeriodo" width="1000" :fullscreen="$vuetify.breakpoint.smAndDown">
      <filtro-periodo v-if="dialogPeriodo" @onClose="dialogPeriodo = false" />
    </v-dialog>
  </div>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator'
import Calendar from '~/components/turnos/calendar.vue'
import { TurnosStore } from '~/store/TurnosStore'
import { AppStore } from '~/store/AppStore'
import FormTurnos from '~/components/turnos/formTurnos.vue'
import { App } from '~/core/App'
import AppToast from '~/core/utils/AppToast'
import UpWebView from '~/components/shared/UpWebView.vue'
import FiltroPeriodo from '~/components/turnos/filtroPeriodo.vue'
@Component({
  components: { FiltroPeriodo, UpWebView, FormTurnos, Calendar },
  head: { title: 'Turnos' },
  middleware: 'auth'
})
export default class turnos extends Vue {
  mounted () {
    turnos.descargardatos()
  }

  abrirForm = false;
  showDialogPDF:boolean = false;
  urlPDF:string = '';
  dialogPeriodo:boolean = false;

  private static async descargardatos () {
    AppStore.SHOW_LOADING('Cargando...')
    try {
      await TurnosStore.descargarTurnos()
    } catch (e) {
    }
    AppStore.HIDE_LOADING()
  }

  imprimirTurno (idclientes) {
    const f = {
      idclientes
    }

    AppStore.SHOW_LOADING('Descargando datos...')

    const url = 'comprobantes/turno'
    App.$axios.get(url, {
      headers: { Accept: 'application/json' },
      params: f,
      responseType: 'blob'
    }).then((res) => {
      const data: Blob = res.data
      this.urlPDF = window.URL.createObjectURL(data)
      this.showDialogPDF = true
    }).catch(() => {
      AppToast.error('Hubo un error al descargar los datos para imprimir')
    }).finally(() => {
      AppStore.HIDE_LOADING()
    })
  }
}
</script>

<style lang="scss">

</style>
